<?php
/*************************************************************************/
/* Configuration                                                         */
/*************************************************************************/

//Where to store cache files? Webserver needs wirte access!
$foocache[cachedir] = $_SERVER[DOCUMENT_ROOT]."/cache";
//Maximum allowed age for cache files (in seconds)
$foocache[maxage]   = 1*24*60*60; //one day
//Referencefile no cachefile may be older than that file
$foocache[reffile]  = $_SERVER[DOCUMENT_ROOT].'/inc/recache';
//optional path to the tidy binary leave blank if you don't want it
$foocache[tidy]     = $_SERVER[DOCUMENT_ROOT].'/cgi-bin/tidy';
//options for tidy you should use the second one if your input files are
//not in iso-8859-1 charset
$foocache[tidyopts] = "-m -i -wrap 0 --drop-empty-paras false -ascii --tidy-mark false";
//$foocache[tidyopts] = "-m -i -wrap 0 --drop-empty-paras false -raw --tidy-mark false";

//These tags are used when the optional query marking is used (see README)
$foocache[hi_in]    = '<span style="background-color:#ffffcc">';
$foocache[hi_out]   = '</span>';

/*************************************************************************/
/* License                                                               */
/*************************************************************************/

// This is free Software (GPL)
// see COPYING for details

/*************************************************************************/
/* No changes needed below                                               */
/*************************************************************************/

function foocache_start(){
  if (defined("NOFOOCACHE")) return;

  global $foocache;
  $foocache[ltime]=foocache_time();
  
  //construct filename from requesturi and post params
  $md5  = md5($_SERVER[REQUEST_URI].@join("",$_POST));
  $file = $foocache[cachedir].'/'.$md5;
  
  //valid cachedata available? load it and stop further processing
  if( (file_exists($file)) &&
      ((time()-filemtime($file)) < $foocache[maxage]) &&
      (filemtime($foocache[reffile]) < filemtime($file)) &&
      (filemtime($file) > filemtime($_SERVER[SCRIPT_FILENAME])) ){
    $data = join("",file($file));
    //hilight query:
    if(!empty($foocache[query])){
      $data = foocache_hilight($data);
    }
    print $data;
    $t = round(foocache_time() - $foocache[ltime],3);
    print "\n<!-- foocache: site processed in $t sec (cache used) -->";
    exit;
  }
  //no cachedata found start capturing output
  ob_start();
}

function foocache_hilight($data){
  global $foocache;
  $in  = $foocache[hi_in];
  $out = $foocache[hi_out];
  $queries = preg_split ("/\s/",$foocache[query],-1,PREG_SPLIT_NO_EMPTY);
  foreach ($queries as $q){
    $q = preg_quote($q,'/');
    $data = preg_replace("/((<[^>]*)|$q)/ie", '"\2"=="\1"? "\1":"${in}\1${out}"', $data);
  }
  return $data;
}

function foocache_stop(){
  if (defined("NOFOOCACHE")) return;
  global $foocache;

  //construct filename from requesturi and post params
  $md5  = md5($_SERVER[REQUEST_URI].@join("",$_POST));
  $file = $foocache[cachedir].'/'.$md5;
  //get contents from the outputbuffer
  $data = ob_get_contents();
  $length = ob_get_length();
  //flush the outputbuffer and stop capturing
  ob_end_clean();
  //write the cachefile
  fwrite(fopen("$file", "w"),$data,$length);
  
  $log = $foocache[cachedir].'/tidy.err';
  //try to tidy the cachefile
  if(is_executable($foocache[tidy])){
    system("$foocache[tidy] $foocache[tidyopts] -f $log $file");
  }
  
  //get the cachefile
  $data = join("",file($file));
  
  //hilight query:
  if(!empty($foocache[query])){
    $data = foocache_hilight($data,$foocache[query]);
  }
  
  //print the cachefile
  print $data;
  
  $t = round(foocache_time() - $foocache[ltime],3);
  print "\n<!-- foocache: site processed in $t sec (no cache used) -->";
  
  //clean up and delete all other old cache files
  foocache_cleanup();
}

function foocache_touch(){
  global $foocache;
  fwrite(fopen($foocache[reffile], "w"),"touched");
}

function foocache_time(){ 
  list($usec, $sec) = explode(" ",microtime()); 
  return ((float)$usec + (float)$sec);
} 

function foocache_cleanup(){
  global $foocache;
  
  $handle = opendir($foocache[cachedir]);
  while ($file = readdir ($handle)) {
    $file = $foocache[cachedir].'/'.$file;
    if(is_dir($file)) continue;
    if( is_file($file) &&
        (
          ( (time() - filemtime($file)) > $foocache[maxage]  ) ||
          ( filemtime($foocache[reffile]) > filemtime($file) )
        )
      )
    {
      unlink($file);
    }
  }
  closedir($handle); 
}

?>
